Markov chain Monte Carlo (MCMC) estimation provides a solution to the
complex integration problems that are faced in the Bayesian analysis
of statistical problems.  The implementation of MCMC algorithms is,
however, code intensive and time consuming.  We have developed a
Python package, which is called PyMCMC, that aids in the construction
of MCMC samplers and helps to substantially reduce the likelihood of
coding error, as well as aid in the minimisation of repetitive code.
PyMCMC contains classes for Gibbs, Metropolis Hastings, independent
Metropolis Hastings, random walk Metropolis Hastings, orientational
bias Monte Carlo and slice samplers as well as specific modules for
common models such as a module for Bayesian regression analysis.
PyMCMC is straightforward to optimise, taking advantage of the Python
libraries Numpy and Scipy, as well as being readily extensible with C
or Fortran.

c Fortran 77 code used in the Bayesian estimation of GLMs
c Copyright (C) 2011  Chris Strickland

c This program is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.

c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.

c You should have received a copy of the GNU General Public License
c along with this program.  If not, see <http://www.gnu.org/licenses/>.


c File is fortran code to assist in the estimation of the generalised
c linear model.
      
      real*8 function llink(x)
      implicit none
      real*8 x

      llink=1.0/(1.0+exp(-x))

      return
      end function llink

      real*8 function lllink(x)
      implicit none
      real*8 x,maxx

      maxx=max(0.0,x)
      lllink=x-log(exp(-maxx)+exp(x-maxx))-maxx
      return
      end function lllink

      real*8 function lomllink(x)
      implicit none
      real*8 x,maxx

      maxx=max(0.0,x)
      lomllink=-log(exp(-maxx)+exp(x-maxx))-maxx
      
      return
      end function lomllink
      

      
            
      real*8 function logl_logit(xb,y,ni,n)
      implicit none
      integer n,i
      real*8 xb(n),y(n),ni(n),lomllink,lllink

cf2py intent(in) xb
cf2py intent(in) y
cf2py intent(in) ni
cf2py intent(in) n


      logl_logit=0.0
c$omp parallel default(shared) private(i)
c$omp do reduction(+:logl_logit)
      do i=1,n
          logl_logit=logl_logit+y(i)*lllink(xb(i))+(ni(i)-y(i))*
     + lomllink(xb(i))
      enddo
c$omp end do
c$omp end parallel
      return
      end function logl_logit
       
      subroutine score(s,y,xb,x,ni,n,k)
      implicit none
      integer n,k,i,t
      real*8 y(n),x(n,k),alpha,s(k),xb(n),ni(n)
      real*8 llink, beta

cf2py intent(inout) s
cf2py intent(in) y
cf2py intent(in) xb
cf2py intent(in) ni
cf2py intent(in) x
cf2py intent(in) n
cf2py intent(in) k
    
c$omp parallel default(shared) private(t,i,beta)
      do i=1,k
c$omp single 
          alpha=0.0
c$omp end single
c$omp do reduction(+:alpha)
          do t=1,n
              beta=y(t)-ni(t)*llink(xb(t))
              alpha=alpha+beta*x(t,i)
          enddo
c$omp end do
c$omp single
          s(i)=alpha
c$omp end single
      enddo
c$omp end parallel

!      do i=1,k
!          s(i)=0.0
!      enddo
      
!      do i=1,n
!          alpha=y(i)-ni(i)*llink(xb(i))
!          call daxpy(k,alpha,x(i,:),1,s,1)
!      enddo
      end subroutine score
        
      subroutine calcxxp(xxp,x,ni,n,k)
      implicit none
      integer n,k,i
      real*8 x(n,k),xxp(k,k,n),alpha,ni(n)

cf2py intent(inout) xxp
cf2py intent(in) x  
cf2py intent(in) ni
cf2py intent(in) n
cf2py intent(in) k  

      do i=1,n
          alpha=ni(i)
          call dger(k,k,alpha,x(i,:),1,x(i,:),1,xxp(:,:,i),k)
      enddo
      
      end subroutine calcxxp
      

      subroutine hessian(h,xxp,xb,n,k)
      implicit none
      integer n,k,i,j,t
      real*8 h(k,k),xxp(k,k,n),xb(n)
      real*8 alpha,lam,llink, beta

cf2py intent(inout) h
cf2py intent(in) xxp
cf2py intent(in) xb
cf2py intent(in) n
cf2py intent(in) k
      
c$omp parallel default(shared) private(i,j,t,lam,beta)
      do i=1,k
          do j=1,k
c$omp single
              alpha=0.0
c$omp end single
c$omp do reduction(+:alpha)
              do t=1,n
                  lam=llink(xb(t))
                  beta=lam*(1.0-lam)
                  alpha=alpha+beta*xxp(j,i,t)
              enddo
c$omp end do
c$omp single
              h(j,i)=alpha
c$omp end single
          enddo
      enddo
c$omp end parallel

!      do i=1,k
!          do j=1,k
!              h(j,i)=0.0
!          enddo
!      enddo
      

!      do i=1,n
!          lam=llink(xb(i))
!          alpha=lam*(1.0-lam)
!          do j=1,k
!              call daxpy(k,alpha,xxp(:,j,i),1,h(:,j),1)
!          enddo
!      enddo
      
      end subroutine hessian

      subroutine xmbeta(xb,x,b,n,k)
      implicit none
      integer n,k
      real*8 xb(n),x(n,k),b(k),alpha,beta

      alpha=1.0
      beta=0.0
      call dgemv('n',n,k,alpha,x,n,b,1,beta,xb,1)

      end subroutine xmbeta
      
      
      subroutine lnewtonr(y,x,xb,theta,ltheta,h,xxp,s,ni,k,n)
      implicit none
      integer k,i,info,n
      real*8 x(n,k),h(k,k),s(k),xxp(k,k,n),ni(n)
      real*8 xb(n),y(n),theta(k),ltheta(k)
      real*8 diff,tol,alpha

      diff=1.0
      tol=1E-5

cf2py intent(in) y
cf2py intent(in) x
cf2py intent(in) xb
cf2py intent(in) ni
cf2py intent(inout) theta
cf2py intent(in) ltheta
cf2py intent(in) h
cf2py intent(in) xxp
cf2py intent(in) s
cf2py intent(in) k
cf2py intent(in) n


      alpha=1.0

      do while (diff.gt.tol)
          call dcopy(k,theta,1,ltheta,1)
          call xmbeta(xb,x,theta,n,k)
          call hessian(h,xxp,xb,n,k)
          call score(s,y,xb,x,ni,n,k)
          call dposv('u',k,1,h,k,s,k,info)
          call daxpy(k,alpha,s,1,theta,1)

          if (info.ne.0) then
              print *, "Warning Newton Raphson"
          endif
          
          diff=0.0
          do i=1,k
              diff=diff+(theta(i)-ltheta(i))**2
          enddo
          diff=sqrt(diff)
      enddo
          
      end subroutine lnewtonr
      

c     Function calculates the autocorrelation function
c     Copyright (C) 2010 Chris Strickland

c     This program is free software: you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation, either version 3 of the License, or
c     (at your option) any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program.  If not, see <http://www.gnu.org/licenses/>.


c     subroutine constructs the upper Cholesky triangle used to simulate
c     simulate from the cholesky decomposition. See Strickland et al
c     2009. This subroutine is called from regtools.py in PyMCMC.

      subroutine chol_wishart(rn,rc,u,c,r,p)
      implicit none
      integer p,i,j,k
      real*8 rc(p),rn(*),u(p,p),c(p,p),r(p,p)
      real*8 alpha, beta

cf2py intent(in) rc
cf2py intent(in) rn
cf2py intent(in) u
cf2py intent(in) c
cf2py intent(inout) r
cf2py intent(in) p

      k=1
      do i=1,p
          u(i,i)=sqrt(rc(i))
          do j=i+1,p
              u(i,j)=rn(k)
              k=k+1
          enddo
          do j=1,i-1
              u(i,j)=0.0
          enddo
      enddo

      alpha=1.0
      beta=0.0

      call dgemm('n','n',p,p,p,alpha,c,p,u,p,beta,r,p)
      end

c     routine used to sample from the wishart distribution
      subroutine chol_wishart2(rn,rc,u,uc,so,ifo,p,pr)
      implicit none
      integer p,pr,i,j,k,ifo
      real*8 rc(p),rn(pr),u(p,p),so(p,p)
      real*8 uc(p,p)
      real*8 alpha

cf2py intent(in) rc
cf2py intent(in) rn
cf2py intent(inplace) u
cf2py intent(in) uc
cf2py intent(in) c
cf2py intent(in) so
cf2py intent(in) p
cf2py intent(in) pr

      k=1
      do i=1,p
          u(i,i)=sqrt(rc(i))
          uc(i,i)=u(i,i)
          do j=i+1,p
              u(i,j)=rn(k)
              k=k+1
          enddo
          do j=1,i-1
              u(i,j)=0.0
          enddo
      enddo

      do j=1,p
          call dcopy(p,u(:,j),1,uc(:,j),1)
      enddo

      call dpotrf('u',p,so,p,ifo)
      alpha=1.0
      call dtrsm('l','u','t','n',p,p,alpha,so,p,u,p)
      call dtrsm('l','u','n','n',p,p,alpha,so,p,u,p)
      call dtrmm('l','u','t','n',p,p,alpha,uc,p,u,p)
      end




      
c     subroutine constructs second shape parameter for 
c     wishart distribution from residuals
      subroutine calc_sobar(su,so,res,p,n)
      implicit none
      integer n,p,t,i
      real*8 su(p,p),so(p,p),res(n,p)
      real*8 alpha

cf2py intent(in) su
cf2py intent(inout) so
cf2py intent(in) res
cf2py intent(in) p
cf2py intent(in) n

      do i=1,p
          call dcopy(p,su(:,i),1,so(:,i),1)
      enddo

      alpha=1.0
      do t=1,n
          call dger(p,p,alpha,res(t,:),1,res(t,:),1,so,p)
      enddo
      end
          

c Modified by Chris Strickland 2012 for use with Python and Numpy's
c random number generator
c
c  A C-program for MT19937, with initialization improved 2002/1/26.
c  Coded by Takuji Nishimura and Makoto Matsumoto.
c
c  Before using, initialize the state by using init_genrand(seed)  
c  or init_by_array(init_key, key_length).
c
c  Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
c  All rights reserved.                          
c  Copyright (C) 2005, Mutsuo Saito,
c  All rights reserved.                          
c
c  Redistribution and use in source and binary forms, with or without
c  modification, are permitted provided that the following conditions
c  are met:
c
c    1. Redistributions of source code must retain the above copyright
c       notice, this list of conditions and the following disclaimer.
c
c    2. Redistributions in binary form must reproduce the above copyright
c       notice, this list of conditions and the following disclaimer in the
c       documentation and/or other materials provided with the distribution.
c
c    3. The names of its contributors may not be used to endorse or promote 
c       products derived from this software without specific prior written 
c       permission.
c
c  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
c  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
c  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
c  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
c  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
c  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
c  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
c  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
c  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
c  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
c  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
c
c
c  Any feedback is very welcome.
c  http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html
c  email: m-mat @ math.sci.hiroshima-u.ac.jp (remove space)
c
c-----------------------------------------------------------------------
c  FORTRAN77 translation by Tsuyoshi TADA. (2005/12/19)
c
c     ---------- initialize routines ----------
c  subroutine init_genrand(seed): initialize with a seed
c  subroutine init_by_array(init_key,key_length): initialize by an array
c
c     ---------- generate functions ----------
c  integer function genrand_int32(): signed 32-bit integer
c  integer function genrand_int31(): unsigned 31-bit integer
c  double precision function genrand_real1(): [0,1] with 32-bit resolution
c  double precision function genrand_real2(): [0,1) with 32-bit resolution
c  double precision function genrand_real3(): (0,1) with 32-bit resolution
c  double precision function genrand_res53(): (0,1) with 53-bit resolution
c
c  This program uses the following non-standard intrinsics.
c    ishft(i,n): If n>0, shifts bits in i by n positions to left.
c                If n<0, shifts bits in i by n positions to right.
c    iand (i,j): Performs logical AND on corresponding bits of i and j.
c    ior  (i,j): Performs inclusive OR on corresponding bits of i and j.
c    ieor (i,j): Performs exclusive OR on corresponding bits of i and j.
c
c-----------------------------------------------------------------------
c     generates a random number on [0,0xffffffff]-interval
c-----------------------------------------------------------------------

      integer function genrand_int32(mt,mag01,argv)
c     argv(1) = mti
c     argv(2) = UPPER_MASK
c     argv(3) = LOWER_MASK
c     argv[4] = T1_MASK
c     argv[5] = T2_MASK

      integer N,M
      parameter (N=624)
      parameter (M=397)
      integer mt(0:N-1)
      integer y,kk, argv(6)
      integer mag01(0:1)


      if(argv(1).ge.N)then
        do 100 kk=0,N-M-1
          y=ior(iand(mt(kk),argv(2)),iand(mt(kk+1),argv(3)))
          mt(kk)=ieor(ieor(mt(kk+M),ishft(y,-1)),mag01(iand(y,1)))
  100   continue
        do 200 kk=N-M,N-1-1
          y=ior(iand(mt(kk),argv(2)),iand(mt(kk+1),argv(3)))
          mt(kk)=ieor(ieor(mt(kk+(M-N)),ishft(y,-1)),mag01(iand(y,1)))
  200   continue
        y=ior(iand(mt(N-1),argv(2)),iand(mt(0),argv(3)))
        mt(kk)=ieor(ieor(mt(M-1),ishft(y,-1)),mag01(iand(y,1)))
        argv(1)=0
      endif
c
      y=mt(argv(1))
      argv(1)=argv(1)+1
c
      y=ieor(y,ishft(y,-11))
      y=ieor(y,iand(ishft(y,7),argv(4)))
      y=ieor(y,iand(ishft(y,15),argv(5)))
      y=ieor(y,ishft(y,-18))
c
      genrand_int32=y
      return
      end

c-----------------------------------------------------------------------
c     fills array with uniform random numbers      
c-----------------------------------------------------------------------
      subroutine randv(rndv, mt, mag01, argv, n)
      implicit none
      integer mt(624),mag01(2),argv(6), n, i
      real*8 rndv(n), genrand_res53
      
cf2py intent(inout) rndv
cf2py intent(inout) mt
cf2py intent(inout) mag0
cf2py intent(inout) argv


      do i=1,n
          rndv(i)=genrand_res53(mt,mag01,argv)
      enddo
      end subroutine randv

      subroutine randm(rndm, mt, mag01, argv, n, m)
      implicit none
      integer n,m
      integer mt(624),mag01(2),argv(6), i, j
      real*8 rndm(n,m), genrand_res53

cf2py intent(inout) rndm
cf2py intent(inout) mt
cf2py intent(inout) mag0
cf2py intent(inout) argv

      do i=1,n
          do j=1,m
              rndm(i,j)=genrand_res53(mt,mag01,argv)
          enddo
      enddo
      end subroutine randm

      subroutine randa3d(rnda, mt, mag01, argv, n, m,r)
      implicit none
      integer n,m,r
      integer mt(624),mag01(2),argv(6), i, j, k
      real*8 rnda(n,m,r), genrand_res53

cf2py intent(inout) rnda
cf2py intent(inout) mt
cf2py intent(inout) mag0
cf2py intent(inout) argv
      do i=1,n
          do j=1,m
              do k=1,r
                  rnda(i,j, k)=genrand_res53(mt,mag01,argv)
              enddo
          enddo
      enddo
      end subroutine randa3d
      
c-----------------------------------------------------------------------
c     generates a random number from exponential (1)
c-----------------------------------------------------------------------

      real*8 function rand_exp(mt, mag01, argv)
      implicit none
      integer mt(624),mag01(2),argv(6)
      real*8 genrand_res53

      rand_exp = -log(genrand_res53(mt,mag01, argv))
      return
      end function rand_exp

      subroutine randv_exp(rndv, mt, mag01, argv, n)
      implicit none
      integer mt(624),mag01(2),argv(6), n, i
      real*8 rndv(n), genrand_res53
      
cf2py intent(inout) rndv
cf2py intent(inout) mt
cf2py intent(inout) mag0
cf2py intent(inout) argv


      do i=1,n
          rndv(i)=-log(genrand_res53(mt,mag01,argv))
      enddo
      end subroutine randv_exp

      subroutine randm_exp(rndm, mt, mag01, argv, n, m)
      implicit none
      integer n,m
      integer mt(624),mag01(2),argv(6), i, j
      real*8 rndm(n,m), genrand_res53

cf2py intent(inout) rndm
cf2py intent(inout) mt
cf2py intent(inout) mag0
cf2py intent(inout) argv

      do i=1,n
          do j=1,m
              rndm(i,j)=-log(genrand_res53(mt,mag01,argv))
          enddo
      enddo
      end subroutine

      subroutine randa3d_exp(rnda, mt, mag01, argv, n, m,r)
      implicit none
      integer n,m,r
      integer mt(624),mag01(2),argv(6), i, j, k
      real*8 rnda(n,m,r), genrand_res53

cf2py intent(inout) rnda
cf2py intent(inout) mt
cf2py intent(inout) mag0
cf2py intent(inout) argv
      do i=1,n
          do j=1,m
              do k=1,r
                  rnda(i,j, k)=-log(genrand_res53(mt,mag01,argv))
              enddo
          enddo
      enddo
      end subroutine randa3d_exp


c-----------------------------------------------------------------------
c     generates a random number from a truncated standard normal
c     distribution with a lowerbound of a and an upperbound of b   
c----------------------------------------------------------------------

      real*8 function tnorm(a,b,mt,mag01,argv,cached)
      implicit none
      integer mt(624),mag01(2),argv(6)
      real*8 a,b,ta,tb
      real*8 t1,t2,t3,t4,pnorm, mult
      real*8 ratio, cached(1), norm_r, exp_r
      real*8 argmax, uni_r, hnorm_r

      parameter(t1=0.150)
      parameter(t2=2.18)
      parameter(t3=0.725)
      parameter(t4=0.45)
      ta = a
      tb = b

      if (ta.lt.-15.0.and.tb.gt.15.0) then
          !normal rejection sampling
          !print*, "nrs", ta, tb
          tnorm = norm_r(a,b,mt,mag01,argv,cached)

      else if (a.lt.-15) then
          ta = -b
          tb = -a
          mult=-1.0
      else if (b.lt.0) then
          ta = -b
          tb = -a
          mult=-1.0
      else
          mult=1.0
      endif


      if (b.gt.15) then !treat b as infinity
          if (ta.le.t4) then
              !normal rejection sampling
              !print *, "nrs",ta,tb
              tnorm = norm_r(ta,tb,mt,mag01,argv,cached)
          else
              !exponential rejection sampling
              tnorm = exp_r(ta,tb,mt,mag01,argv)
              !print *, "ers",ta,tb,tnorm
          endif
      else if (ta.le.0.and.tb.gt.0) then
          if (pnorm(ta).le.t1.or.pnorm(tb).le.t1) then
              !normal rejection sampling
              !print *, "nrs",ta,tb
              tnorm = norm_r(ta,tb,mt,mag01,argv,cached)
          else
              !uniform rejection sampling
              argmax = 0.0
              !print *, "urs",ta,tb
              tnorm = uni_r(ta,tb,mt,mag01,argv, argmax)
          endif
      else !if (a.gt.0) then
          ratio = pnorm(ta) / pnorm(tb)
          if (ratio.lt.t2) then
              !uniform rejection sampling
              argmax = ta
              !print *, "urs",ta,tb
              tnorm = uni_r(ta,tb,mt,mag01,argv, argmax)
          else if (ratio.gt.t1.and.ta.lt.t3) then
              !half-normal rejections sampling
              !print *, "hns", ta,tb
              tnorm = hnorm_r(ta,tb,mt,mag01,argv,cached)

          else
              !exponential rejection sampling
              tnorm = exp_r(ta,tb,mt,mag01,argv)
              !print *, "ers",ta,tb,tnorm
          endif
      endif
      tnorm = tnorm * mult




      
      return
      end function tnorm


      subroutine randv_tnorm(rnd,a, b,mt,mag01,argv,cached,n,na)
      implicit none
      integer n,i,na
      integer mt(624),mag01(2),argv(6)
      real*8 cached(1), rnd(n), tnorm, a(na), b(na)
      
cf2py intent(inout) rnd
cf2py intent(inplace) mt
cf2py intent(in) mag01
cf2py intent(inplace) argv
cf2py intent(inplace) cached

      if (na.eq.1) then
          do i=1,n
              rnd(i) =  tnorm(a(1),b(1), mt,mag01,argv,cached)
          enddo
      else
          do i=1,n
              rnd(i) =  tnorm(a(i),b(i), mt,mag01,argv,cached)
          enddo
      endif

      end subroutine randv_tnorm
      
      
      subroutine randm_tnorm(rnd,a, b, mt,mag01,argv,cached,n,m,na,ma)
      implicit none
      integer n,m,i,j,na,ma
      integer mt(624),mag01(2),argv(6)
      real*8 cached(1), rnd(n,m), tnorm, a(na,ma), b(na,ma)
      
cf2py intent(inout) rnd
cf2py intent(inplace) mt
cf2py intent(in) mag01
cf2py intent(inplace) argv
cf2py intent(inplace) cached

      if (na.eq.1.and.ma.eq.1) then
          do i=1,n
              do j=1,m
                  rnd(i,j) =  tnorm(a(1,1),b(1,1),mt,mag01,argv,cached)
              enddo
          enddo
      else
          do i=1,n
              do j=1,m
                  rnd(i,j) =  tnorm(a(i,j), b(i,j),mt,mag01,argv,cached)
              enddo
          enddo
      endif

      end subroutine randm_tnorm

      subroutine randa3d_tnorm(rnd,a, b, mt,mag01,argv,cached,n,m,r,
     + na,ma,ra)
      implicit none
      integer n,m,r,i,j,k,na,ma,ra
      integer mt(624),mag01(2),argv(6)
      real*8 cached(1), rnd(n,m,r), tnorm, a(na,ma,ra), b(na,ma,ra)
      
cf2py intent(inout) rnd
cf2py intent(inplace) mt
cf2py intent(in) mag01
cf2py intent(inplace) argv
cf2py intent(inplace) cached

      if (na.eq.1.and.ma.eq.1.and.ra.eq.1) then
          do i=1,n
              do j=1,m
                  do k=1,r
                      rnd(i,j,k)= tnorm(a(1,1,1),b(1,1,1),mt,mag01,
     + argv,cached)
                  enddo
              enddo
          enddo
      else
          do i=1,n
              do j=1,m
                  do k=1,r
                      rnd(i,j,k)= tnorm(a(i,j,k),b(i,j,k),mt,mag01,
     + argv,cached)
                  enddo
              enddo
          enddo
      endif
      end subroutine randa3d_tnorm


c     normal rejection sampling
      real*8 function norm_r(a,b,mt,mag01,argv,cached)
      implicit none
      integer mt(624),mag01(2),argv(6)
      real*8 a,b, cached(1),randn
      norm_r=randn(mt,mag01,argv,cached)
      do while (norm_r.lt.a.or.norm_r.gt.b)
          norm_r=randn(mt,mag01,argv,cached)
      enddo
      return
      end function norm_r


c     half normal rejection sampling
      real*8 function hnorm_r(a,b,mt,mag01,argv,cached)
      implicit none
      integer mt(624),mag01(2),argv(6)
      real*8 a,b, cached(1),randn

      hnorm_r=abs(randn(mt,mag01,argv,cached))
      do while(hnorm_r.lt.a.or.hnorm_r.gt.b)
          hnorm_r=abs(randn(mt,mag01,argv,cached))
      enddo
      return
      end function hnorm_r
      
      

c     exponential rejection sampling
      real*8 function exp_r(a,b,mt,mag01,argv)
      implicit none
      integer mt(624),mag01(2),argv(6)
      real*8 a,b
      real*8 lam,randu, genrand_res53,ap, rand_exp

      lam=1.0/a
      randu = genrand_res53(mt,mag01,argv)
      exp_r = a + lam * rand_exp(mt,mag01,argv)
      ap = exp(-0.5*exp_r ** 2) / exp(-a*exp_r)

      do while(randu.gt.ap.or.exp_r.gt.b)
          randu = genrand_res53(mt,mag01,argv)
          exp_r = a + lam * rand_exp(mt,mag01,argv)
          ap = exp(-0.5*exp_r ** 2) / exp(-a*exp_r)
      enddo
      return
      end function exp_r

c     uniform rejection sampling
      real*8 function uni_r(a,b,mt,mag01,argv, argmax)
      implicit none
      integer mt(624),mag01(2),argv(6)
      real*8 a,b,randu, var,argmax,ap, genrand_res53
      real*8 pnorm
      var = b-a

      uni_r = a + genrand_res53(mt,mag01,argv) * var
      randu = genrand_res53(mt,mag01,argv)
      ap = pnorm(uni_r) / pnorm(argmax)
      
      do while(randu.gt.ap)
          uni_r = a + genrand_res53(mt,mag01,argv) * var
          randu = genrand_res53(mt,mag01,argv)
          ap = pnorm(uni_r) / pnorm(argmax)
      enddo
      return
      end function uni_r
      
      
      

      real*8 function pnorm(x)
      implicit none
      real*8 pi,x
      parameter (pi=3.141592653589793)
      pnorm=(2*pi)**(-0.5)*exp(-0.5*x**2)
      
      return
      end function pnorm
      


c-----------------------------------------------------------------------
c     function generates random normal variable
c     code ported from c code in randomkit.c (NumPy library)
c-----------------------------------------------------------------------
      real*8 function randn(mt,mag01,argv,cached)
      implicit none
      integer mt(624),mag01(2),argv(6)
      real*8 cached(1),f,x1,x2,r2, genrand_res53



      if (argv(6).eq.1) then
          !used cached value
          randn = cached(1)
          argv(6) = 0
      else
          r2 = 0.0

          do while(r2.ge.1.0.or.r2.eq.0.0)
              x1 = 2.0 * genrand_res53(mt,mag01,argv) - 1.0
              x2 = 2.0 * genrand_res53(mt,mag01,argv) - 1.0
              r2 = x1 * x1 + x2 * x2
          enddo

          f = sqrt(-2.0 * log(r2)/r2)
          cached = f * x1
          argv(6) = 1
          randn = f * x2
      endif
      return
      end function randn

      subroutine randv_norm(rnd,mt,mag01,argv,cached,n)
      implicit none
      integer n,i
      integer mt(624),mag01(2),argv(6)
      real*8 cached(1), rnd(n), randn
      
cf2py intent(inout) rnd
cf2py intent(inplace) mt
cf2py intent(in) mag01
cf2py intent(inplace) argv
cf2py intent(inplace) cached

      do i=1,n
          rnd(i) =  randn(mt,mag01,argv,cached)
      enddo
      end subroutine randv_norm
      
      
      subroutine randm_norm(rnd,mt,mag01,argv,cached,n,m)
      implicit none
      integer n,m,i,j
      integer mt(624),mag01(2),argv(6)
      real*8 cached(1), rnd(n,m), randn
      
cf2py intent(inout) rnd
cf2py intent(inplace) mt
cf2py intent(in) mag01
cf2py intent(inplace) argv
cf2py intent(inplace) cached

      do i=1,n
          do j=1,m
              rnd(i,j) =  randn(mt,mag01,argv,cached)
          enddo
          
      enddo
      end subroutine randm_norm

      subroutine randa3d_norm(rnd,mt,mag01,argv,cached,n,m,r)
      implicit none
      integer n,m,r,i,j,k
      integer mt(624),mag01(2),argv(6)
      real*8 cached(1), rnd(n,m,r), randn
      
cf2py intent(inout) rnd
cf2py intent(inplace) mt
cf2py intent(in) mag01
cf2py intent(inplace) argv
cf2py intent(inplace) cached

      do i=1,n
          do j=1,m
              do k=1,r
                  rnd(i,j,k) =  randn(mt,mag01,argv,cached)
              enddo
          enddo
          
      enddo
      end subroutine randa3d_norm
c-----------------------------------------------------------------------
c     generates a random number on [0,1) with 53-bit resolution
c-----------------------------------------------------------------------
      real*8 function genrand_res53(mt,mag01,argv)
      integer mt(624),mag01(2),argv(6)
      integer genrand_int32
      double precision a,b
cf2py intent(inplace) mt
cf2py intent(in) mag01
cf2py intent(inplace) argv
      

      a=dble(ishft(genrand_int32(mt,mag01,argv),-5))
      b=dble(ishft(genrand_int32(mt,mag01,argv),-6))
      if(a.lt.0.d0)a=a+2.d0**32
      if(b.lt.0.d0)b=b+2.d0**32
      genrand_res53=1.0 - (a*67108864.d0+b)/9007199254740992.d0
      return
      end
c-----------------------------------------------------------------------
c     initialize large number (over 32-bit constant number)
c-----------------------------------------------------------------------
      subroutine mt_initln(argv,
     + mag01)
      integer ALLBIT_MASK
      integer TOPBIT_MASK
      integer UPPER_MASK,LOWER_MASK,MATRIX_A,T1_MASK,T2_MASK
      
      integer mag01(0:1), argv(6)

cf2py intent(inout) argv
cf2py intent(inout) mag01

c      common /mt_mask1/ ALLBIT_MASK
c      common /mt_mask2/ TOPBIT_MASK
c      common /mt_mask3/ UPPER_MASK,LOWER_MASK,MATRIX_A,T1_MASK,T2_MASK
c      common /mt_mag01/ mag01
CC    TOPBIT_MASK = Z'80000000'
CC    ALLBIT_MASK = Z'ffffffff'
CC    UPPER_MASK  = Z'80000000'
CC    LOWER_MASK  = Z'7fffffff'
CC    MATRIX_A    = Z'9908b0df'
CC    T1_MASK     = Z'9d2c5680'
CC    T2_MASK     = Z'efc60000'
      TOPBIT_MASK=1073741824
      TOPBIT_MASK=ishft(TOPBIT_MASK,1)
      ALLBIT_MASK=2147483647
      ALLBIT_MASK=ior(ALLBIT_MASK,TOPBIT_MASK)
      UPPER_MASK=TOPBIT_MASK
      LOWER_MASK=2147483647
      MATRIX_A=419999967
      MATRIX_A=ior(MATRIX_A,TOPBIT_MASK)
      T1_MASK=489444992
      T1_MASK=ior(T1_MASK,TOPBIT_MASK)
      T2_MASK=1875247104
      T2_MASK=ior(T2_MASK,TOPBIT_MASK)
      mag01(0)=0
      mag01(1)=MATRIX_A
      argv(2)=UPPER_MASK
      argv(3)=LOWER_MASK
      argv(4)=T1_MASK
      argv(5)=T2_MASK
      return
      end

c Fortran 77 code used in the Bayesian estimation of the loglinear
c model.
c Copyright (C) 2011  Chris Strickland

c This program is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.

c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.

c You should have received a copy of the GNU General Public License
c along with this program.  If not, see <http://www.gnu.org/licenses/>.


c     Fortran 77 code for the log linear model


c Purpose
c =======
c
c Function calculates the log like-lihood function for the
c log linear model up to a constant of proportionality. Specifically
c the log likelihood is calculate as
c
c ln L = Sum_i(-exp(xb(i)) + y(i) * xb(i)). Note that in the Python
c code that calls this function the integrating constant -Sum_i(log(y(i)!))
c is added 
c
c Arguments
c =========
c 
c y - Is the (n x 1) vector of observations y.
c
c xb - Is the (n x 1) vector that is constructed by dot(x, b), where
c      x is an (n x k) matrix of regressors and b is a (k x 1) vector
c      of regression coefficients.
c
c n - Is an integer that defines the number of observations.
c
c =====================================================

      real*8 function logl(xb,y,n)
      implicit none
      integer n,i
      real*8 xb(n),y(n)

cf2py intent(in) xb
cf2py intent(in) y
cf2py intent(in) n

      logl=0.0
c$omp parallel shared(xb,y)
c$omp do reduction(+:logl)
      do i=1,n
          logl=logl+y(i)*xb(i)-exp(xb(i))
      enddo
c$omp end parallel
      return
      end function logl

c Purpose
c =======
c
c The subroutine score returns the score vector.
c
c Arguments
c =========
c 
c s - Is the (k x 1) score vector.
c
c y - Is the (n x 1) vector of observations y.
c
c xb - Is the (n x 1) vector that is constructed by dot(x, b), where
c      x is an (n x k) matrix of regressors and b is a (k x 1) vector
c      of regression coefficients.
c
c x - Is an (n x k) matrix of regressors.
c
c n - Is an integer that defines the number of observations.
c
c k - Is an integer that defines the number of regressors.
c =====================================================


      
      subroutine score(s,y,xb,x,n,k)
      implicit none
      integer n,k,i,t
      real*8 xb(n),x(n,k),s(k),y(n)
      real*8 alpha

cf2py intent(inout) s
cf2py intent(in) y
cf2py intent(in) xb
cf2py intent(in) x
cf2py intent(in) n
cf2py intent(in) k

      
c$omp parallel default(shared) private(t,i)
      do i=1,k
c$omp single 
          alpha=0.0
c$omp end single
c$omp do reduction(+:alpha)
          do t=1,n
              alpha=alpha+(y(t)-exp(xb(t)))*x(t,i)
          enddo
c$omp end do
c$omp single
          s(i)=alpha
c$omp end single
      enddo
c$omp end parallel

c Sequential Implementation
c      do i=1,k
c          s(i)=0.0
c      enddo

c      do i=1,n
c          alpha=y(i)-exp(xb(i))
c          call daxpy(k,alpha,x(i,:),1,s,1)
c      enddo
      end subroutine score
      
c Purpose
c =======
c
c The subroutine calcxxp calculates the outer products
c x(i)x(i)' for i = 1,2,...,n. The result is stored in the
c array xxp.
c
c Arguments
c =========
c 
c xxp - Is a (k x k x n) array that stores the outer products
c x(i)x(i)' for i = 1,2,...,n.
c
c x - Is an (n x k) matrix of regressors.
c
c n - Is an integer that denotes the number of observations.
c
c k - Is an integer that denotes the number of regressors.
c
c =====================================================

          
      subroutine calcxxp(xxp,x,n,k)
      implicit none
      integer n,k,i
      real*8 x(n,k),xxp(k,k,n),alpha

      alpha=1.0

      do i=1,n
          call dger(k,k,alpha,x(i,:),1,x(i,:),1,xxp(:,:,i),k)
      enddo
      
      end subroutine calcxxp

c Purpose
c =======
c
c The subroutine hessian calculates the hessian.
c
c Arguments
c =========
c 
c h - Is a (k x k) matrix that stores the hessian.
c
c xxp - Is a (k x k x n) array that stores the outer products
c x(i)x(i)' for i = 1,2,...,n.
c
c xb - Is the (n x 1) vector that is constructed by dot(x, b), where
c      x is an (n x k) matrix of regressors and b is a (k x 1) vector
c      of regression coefficients.
c
c n - Is an integer that denotes the number of observations.
c
c k - Is an integer that denotes the number of regressors.
c
c =====================================================


      subroutine hessian(h,xxp,xb,n,k)
      implicit none
      integer n,k,i,j,t
      integer seq
      real*8 h(k,k),xxp(k,k,n),xb(n)
      real*8 alpha

cf2py intent(inout) h
cf2py intent(in) xxp
cf2py intent(in) xb
cf2py intent(in) n
cf2py intent(in) k

      
    
c$omp parallel default(shared) private(i,j,t)
      do i=1,k
          do j=1,k
c$omp single
              alpha=0.0
c$omp end single
c$omp do reduction(+:alpha)
              do t=1,n
                  alpha=alpha+exp(xb(t))*xxp(j,i,t)
              enddo
c$omp end do
c$omp single
              h(j,i)=alpha
c$omp end single
          enddo
      enddo
c$omp end parallel
      
c Sequential version
c      do i=1,k
c          do j=1,k
c              h(j,i)=0.0
c          enddo
c      enddo

c      do i=1,n
c          alpha=exp(xb(i))
c          do j=1,k
c              call daxpy(k,alpha,xxp(:,j,i),1,h(:,j),1)
c          enddo
c      enddo
      
      end subroutine hessian
      
      subroutine xmbeta(xb,x,b,n,k)
      implicit none
      integer n,k
      real*8 xb(n),x(n,k),b(k),alpha,beta

      alpha=1.0
      beta=0.0
      call dgemv('n',n,k,alpha,x,n,b,1,beta,xb,1)

      end subroutine xmbeta

      subroutine newtonr(y,x,xb,theta,ltheta,h,xxp,s,ipiv,wk,lwk,k,n)
      implicit none
      integer k,i,j,info,n,ipiv(k),fl,lwk
      real*8 x(n,k),h(k,k),s(k),xxp(k,k,n)
      real*8 xb(n),y(n),theta(k),ltheta(k)
      real*8 diff,tol,alpha,wk(lwk)

      diff=1.0
      tol=1E-5

cf2py intent(in) y
cf2py intent(in) x
cf2py intent(in) xb
cf2py intent(inout) theta
cf2py intent(in) ltheta
cf2py intent(in) h
cf2py intent(in) xxp
cf2py intent(in) s
cf2py intent(in) ipiv
cf2py intent(in) wk
cf2py intent(in) lwk
cf2py intent(in) k
cf2py intent(in) n


      alpha=1.0
      fl=0

      do while (diff.gt.tol)
          call dcopy(k,theta,1,ltheta,1)
          call xmbeta(xb,x,theta,n,k)
          call hessian(h,xxp,xb,n,k)
          call score(s,y,xb,x,n,k)
          call dposv('u',k,1,h,k,s,k,info)
          if (info.ne.0.or.fl.eq.1) then
              !call hessian(h,xxp,xb,n,k)
              !call score(s,y,xb,x,n,k)
              !call dsysv('u',k,1,h,k,ipiv,s,k,wk,lwk,info)
              !fl=1
              print *, "Warning Newton Raphson"
          endif

          call daxpy(k,alpha,s,1,theta,1)

          
          diff=0.0
          do i=1,k
              diff=diff+(theta(i)-ltheta(i))**2
          enddo
          diff=sqrt(diff)
      enddo
          
      end subroutine newtonr
     
c Purpose
c =======
c
c The function intconst works out the integrating constant for the
c likeihood of the log-linear model. Specifically the function returns
c intconst = Sum_i(log(y(i)!))
c
c Arguments
c =========
c          
c y - Is an (n x 1) vector of observations.
c
c n - Is an integer that defines the number of observations.
c
c =====================================================
 
      real*8 function intconst(y,n)
      implicit none
      integer n,i
      real*8 y(n),lgama

cf2py intent(in) y
cf2py intent(in) n


      intconst=0.0
c$omp parallel shared(y)
c$omp do reduction(+:intconst)
      do i=1,n
          intconst=intconst-lgama(y(i)+1)
      enddo
c$omp end parallel
      return
      end function intconst
      

c     Function calculates the autocorrelation function
c     Copyright (C) 2010 Chris Strickland

c     This program is free software: you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation, either version 3 of the License, or
c     (at your option) any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program.  If not, see <http://www.gnu.org/licenses/>.


c     acf is a Fortran77 subroutine for calculating the autocorrelation 
c     function. The computation is done in the time domain. 

c     ts = the timeseries of interest.
c     n = the number of observations.
c     corr =  a vector of length nlag that stores the autocorrelation
c             function for the timeseries of interest on exit.
c     nlag = the number of lags to be used in the calculation of the
c            autocorrelation function.

      subroutine acf(ts,n,corr,nlag)
      integer n,nlag
      double precision ts(n), corr(nlag),mean, var

cf2py intent(in) ts
cf2py intent(in,out) corr
cf2py intent(in) n
cf2py intent(in) nlag
cf2py depend(ts) n
cf2py depend(corr) nlag


      mean=0.0
      do i=1,n
          mean=mean+ts(i)
      enddo

      mean=mean/dble(n)
      

      do i=1,nlag
          corr(i)=0.0
          do j=1,n-i
              corr(i)=corr(i)+(ts(j)-mean)*(ts(j+i-1)-mean)
          enddo
      enddo
      var=corr(1)/dble(n)
    
      do i=1,nlag
          corr(i)=corr(i)/(var*dble(n))
      enddo    
      end
c     end of subroutine acf






      


      

      

c     Used in PyMCMC for the stochastic search algorithm.    
c     Copyright (C) 2010  Chris Strickland
c
c     This program is free software: you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation, either version 3 of the License, or
c     (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program.  If not, see <http://www.gnu.org/licenses/>. 


c     ssreg is a Fortran77 subroutine that is used by the Python package
c     PyMCMC. Specifically ssreg is used to calculate the indicator
c     vector that is used in the Bayesian stochastic search variable
c     selection problem for the normal linear model. The subroutine
c     assumes the the model is specified using a g-prior. If y denotes
c     the observation vector and x denonotes the set of regressors then
c     ypy = y'y
c     g = g from the g-prior
c     xpx = x'x
c     spy = x'y
c     xgxg = a (k,k) matrix used for workings
c     xgy = a (k,1) vector used for workings
c     gam = a (k,1) vector of integers used to store the selection
c           dummies
c     ru = a (k,1) vector of uniform random numbers     
c     w = a (k,6) matrix for workings
c     w2 = a (k,k) matrix for workings
c     ifo = an integer. Equals 0 on return if computuations were
c           successful
c     ifo2 = an integer. Equals 0 on return if computuations were
c            successful
c     n = the number of observations
c     k = the number of regressors
      
      subroutine ssreg(ini,ypy,g,xpx,xpy,xgxg,xgy,gam,ru,w,w2,ifo,
     + ifo2,n,k)
      implicit none
      integer n,k,gam(k),ifo, ifo2,ini
      real*8 xpy(k), g, xpx(k,k), xgy(k),xgxg(k,k),ru(k),ypy
      real*8 w(k,6),w2(k,k), pgamnum,pgamdenom
      integer qgam, sumgam,i
      real*8 probdenom

cf2py intent(inout) gam
cf2py intent(in) ypy
cf2py intent(in) g
cf2py intent(in) xpx
cf2py intent(in) xgxg
cf2py intent(in) w2
cf2py intent(in) xgq
cf2py intent(in) ru
cf2py intent(in) n
cf2py intent(in) k
cf2py intent(inout) ifo
cf2py intent(inout) ifo2
      do i=ini,k
          qgam=sumgam(gam,k)      
          if (gam(i).eq.1) then
              call precalc(qgam,xpy,xpx,xgy,xgxg,w2,gam,w,k,ifo2)
              call probgam(pgamnum,g,ypy,qgam,xgxg,w2,xgy,w,n,k,ifo)
              gam(i)=0
              qgam=qgam-1
              call precalc(qgam,xpy,xpx,xgy,xgxg,w2,gam,w,k,ifo2)
              call probgam(pgamdenom,g,ypy,qgam,xgxg,w2,xgy,w,n,k,ifo)
              pgamdenom=probdenom(pgamnum,pgamdenom)
              if (ru(i)>pgamdenom.or.ifo2.ne.0.or.ifo.ne.0) then
                  gam(i)=1
                  qgam=qgam+1
              endif
          else
              call precalc(qgam,xpy,xpx,xgy,xgxg,w2,gam,w,k,ifo2)
              call probgam(pgamnum,g,ypy,qgam,xgxg,w2,xgy,w,n,k,ifo)
              gam(i)=1
              qgam=qgam+1
              call precalc(qgam,xpy,xpx,xgy,xgxg,w2,gam,w,k,ifo2)
              call probgam(pgamdenom,g,ypy,qgam,xgxg,w2,xgy,w,n,k,ifo)
              pgamdenom=probdenom(pgamnum,pgamdenom)
              if (ru(i)>pgamdenom.or.ifo2.ne.0.or.ifo.ne.0) then
                  gam(i)=0
                  qgam=qgam-1
              endif
          endif
      enddo
      end

c     subroutine that does precalulation for probgam
      subroutine precalc(qgam,xpy,xpx,xgy,xgxg,w2,gam,w,k,ifo2)
      implicit none
      integer k, ifo2,gam(k),qgam
      real*8 xpy(k), xpx(k,k),w2(k,k),xgy(k),xgxg(k,k),w(k,6)

      call calcxpy(xpy,gam,xgy,k)
      call calcxpx(xpx,gam,xgxg,k)
c     calculate prior mean
      call calcpm(qgam,xgxg,w2,gam,w,k,ifo2)
      end
      
c     subroutine calculates the prior mean
      subroutine calcpm(qgam,xgxg,w2,gam,w,k,ifo2)
      implicit none
      integer k,i,j,ifo2,qgam,gam(k)
      real*8  xgxg(k,k),w2(k,k), w(k,6) 

      j=0
      do i=1,k
          if (gam(i).eq.1) then
              w(j,5)=w(i,4)
              j=j+1
          endif
      enddo
      do j=1,qgam
          w(j,1)=w(j,5)
          do i=1,qgam
              w2(i,j)=xgxg(i,j)
          enddo
      enddo
      call dposv('u',qgam,1,w2,k,w(:,1),k,ifo2)
      end  
        
      


c     subroutine calculates the probability of gamma      
      subroutine probgam(pgam,g,ypy,qgam,xgxg,w2,xgy,w,n,k,info)
      implicit none
      integer n, k, qgam,info, i,j
      real*8 pgam, xgxg(k,k),w2(k,k), xgy(k), w(k,6),c1, c2,c3,g, ypy
      real*8 alpha,beta
c     BLAS function declation
      real*8 ddot


      c1=(-dble(qgam)/2.0)*log(g+1.0)
      do j=1,qgam
          w(j,2)=xgy(j)
          do i=1,qgam
              w2(i,j)=xgxg(i,j)
          enddo
      enddo
      alpha=1.0
      beta=0.0
      call dposv('u',qgam,1,w2,k,w(:,2),k,info)
      if(info.eq.0) then
          !c2 = bobar'Vbobar
          c2=g/(g+1)*ddot(qgam,xgy,1,w(:,2),1)
          
          call dgemv('n',qgam,qgam,alpha,xgxg,k,w(:,1),1,beta,w(:,3),1)
          c3=ddot(qgam,w(:,1),1,w(:,3),1)/(g+1.0)

          pgam=c1-(dble(n)/2.0)*log((ypy-c2-c3)/2.)
      else
          pgam=-1.0D256
      endif
      end

c     function returns the probability of the denominator
c     lnp1 is the unnormalised log probability of the numerator, while
c     lnp2 is the unnormalised log probability of the denonator
      real*8 function probdenom(lnp1,lnp2)
      real*8 lnp2,lnp1,maxp,lnsump

      maxp=max(lnp1,lnp2)
      lnsump=log(exp(lnp1-maxp)+exp(lnp2-maxp))+maxp
      probdenom=exp(lnp2-lnsump)
      return
      end

      
c     functions calulates the number of ones in gam      
      integer function sumgam(gam,k)
      integer k, gam(k),i

      sumgam=0
      do i=1,k
          sumgam=sumgam+gam(i)
      enddo
      return
      end    

c     function extracts the rows in xpy that correspond to ones in gam
      subroutine calcxpy(xpy,gam,xgy,k)
      implicit none
      integer k,gam(k), i,j
      real*8 xpy(k), xgy(k)

      j=1
      do i=1,k
          if(gam(i).eq.1) then
              xgy(j)=xpy(i)
              j=j+1
          endif
      enddo
      end

      subroutine calcxpx(xpx,gam,xgxg,k)
      implicit none
      integer k, gam(k),i,j,s,t
      real*8 xpx(k,k),xgxg(k,k) 

      s=1
      t=1
      do j=1,k
          do i=1,k
              if(gam(i).eq.1 .and. gam(j).eq.1) then
                  xgxg(s,t)=xpx(i,j)
                  s=s+1
              endif
          enddo
          if(gam(j).eq.1) then
              t=t+1
          endif
          s=1
      enddo
      end

c     functions for the normal inverted gamma prior
     
c     subroutine samples gamma for normal-inverted gamma prior
      subroutine ssreg_nig(ini,ypy,ldr,vs,vxy,vobar,vubar,gam,xpx,xpy,
     + v,r,nuo,ru,k)

      implicit none
      integer k,gam(k),gami,ifo,ifo2,nuo,i,ini
      real*8 vobar(k,k),vubar(k,k),xpx(k,k),xpy(k),v(k,2),r(k,k)
      real*8 vxy(k),ldr,ypy,vs
      real*8 pgamnum,pgamdenom,ru(k),probdenom,marg

cf2py intent(in) ypy
cf2py intent(in) ldr
cf2py intent(in) vs
cf2py intent(in) vxy
cf2py intent(in) vobar
cf2py intent(in) vubar
cf2py intent(in) gam
cf2py intent(in) xpx
cf2py intent(in) xpy
cf2py intent(in) v
cf2py intent(in) r
cf2py intent(in) gam
cf2py intent(in) nuo
cf2py intent(in) ru
cf2py intent(in) k

      do i=ini,k
          if (gam(i).eq.1) then
              gami=-1 !don't update
              pgamnum=marg(ypy,ldr,vs,vxy,vobar,vubar,gam,xpx,xpy,v,
     + r,gami,ifo,nuo,k)
              gam(i)=0
              gami=i
              pgamdenom=marg(ypy,ldr,vs,vxy,vobar,vubar,gam,xpx,xpy,v,
     + r,gami,ifo2,nuo,k)
              pgamdenom=probdenom(pgamnum,pgamdenom)
              if (ru(i)>pgamdenom.or.ifo2.ne.0.or.ifo.ne.0) then
                  gam(i)=1
                  call update_vubar(vubar,gam,v,r,gami,k)
              endif
          else
              gami=-1
              pgamnum=marg(ypy,ldr,vs,vxy,vobar,vubar,gam,xpx,xpy,v,
     + r,gami,ifo,nuo,k)
              gam(i)=1
              gami=i
              pgamdenom=marg(ypy,ldr,vs,vxy,vobar,vubar,gam,xpx,xpy,v,
     + r,gami,ifo2,nuo,k)
              pgamdenom=probdenom(pgamnum,pgamdenom)
              if (ru(i)>pgamdenom.or.ifo2.ne.0.or.ifo.ne.0) then
                  gam(i)=0
                  call update_vubar(vubar,gam,v,r,gami,k)
              endif
          endif
      enddo
      end


      

c     subroutine to initialise vubar
      subroutine initialise_vubar(vubar,gam,v,r,k)
      implicit none
      integer k,gam(k),i,j
      real*8 vubar(k,k),r(k,k),v(k,2)

cf2py intent(inout) vubar
cf2py intent(in) gam
cf2py intent(in) v
cf2py intent(in) r
cf2py intent(in) k

      do j=1,k
          do i=1,k
              vubar(i,j)=v(i,gam(i)+1)*r(i,j)*v(j,gam(j)+1)
          enddo
      enddo
      end



c     subroutine updates vubar for a change in gamma
      subroutine update_vubar(vubar,gam,v,r,gami,k)
      implicit none
      integer k,gam(k),gami,i,j
      real*8 vubar(k,k),r(k,k),v(k,2),tmp

      do j=1,k
          vubar(gami,j)=v(gami,gam(gami)+1)*r(gami,j)
      enddo
      do i=1,k
          tmp=v(gami,gam(gami)+1)*vubar(i,gami)
          vubar(i,gami)=tmp
      enddo
      end


c     subroutine calculates marginal likelihood
      real*8 function marg(ypy,ldr,vs,vxy,vobar,vubar,gam,xpx,xpy,v,r,
     + gami,ifo,nuo,k)
      implicit none
      integer k,gam(k),gami,ifo,nuo,i
      real*8 vobar(k,k),vubar(k,k),xpx(k,k),xpy(k),v(k,2),r(k,k)
      real*8 alpha,beta,vxy(k),ddot,vso,ldr,ypy,vs
      real*8 lndetvo,logdetvu
        
      if (gami.ne.-1) then
          call update_vubar(vubar,gam,v,r,gami,k)
      endif
      alpha=1.0
      do i=1,k
          call dcopy(k,vubar(:,i),1,vobar(:,i),1)
          call daxpy(k,alpha,xpx(:,i),1,vobar(:,i),1)
      enddo

      call dpotrf('u',k,vobar,k,ifo)
      if (ifo.eq.0) then
          call dcopy(k,xpy,1,vxy,1)
          call dtrsv('u','t','n',k,vobar,k,vxy,1)
          beta=0.0
          vso=vs+ypy-ddot(k,vxy,1,vxy,1)

          lndetvo=0.0
          do i=1,k
              lndetvo=lndetvo+log(vobar(i,i))
          enddo

          marg=0.5*logdetvu(v,gam,ldr,k)-lndetvo-dble(nuo)/2.0*
     + log(vso/2.0)
      else
          marg=-1.0D256
      endif
      return
      end
c     function returns the log determinant of vubar
      real*8 function logdetvu(v,gam,ldr,k)
      implicit none
      integer i,k,gam(k)
      real*8 v(k,k),ldr


      logdetvu=0.0
      do i=1,k
          logdetvu=logdetvu+log(v(i,gam(i)+1))
      enddo
      logdetvu=2.0*logdetvu+ldr
      return
      end
      

c     Stochastic search gamma|beta, sigma normal-inverted gamma prior

c     subroutine to sample gamma

      subroutine ssregcbeta_nig(ini,beta,sig,vub,ldr,vubar,gam,v,r,ru,k)
      implicit none
      integer k,gam(k),gami,i,ini
      real*8 v(k,2),r(k,k),beta(k),sig,vub(k),vubar(k,k)
      real*8 ldr,pgamnum,pgamdenom,ru(k),probdenom,probgambet

cf2py intent(in) beta
cf2py intent(in) sig
cf2py intent(in) vub
cf2py intent(in) ldr
cf2py intent(in) vubar
cf2py intent(in) gam
cf2py intent(in) v
cf2py intent(in) r
cf2py intent(in) gam
cf2py intent(in) ru
cf2py intent(in) k

      do i=ini,k
          if (gam(i).eq.1) then
              gami=-1
              pgamnum=probgambet(ldr,beta,vub,sig,vubar,v,r,gami,gam,k)
              gam(i)=0
              gami=i
              pgamdenom=probgambet(ldr,beta,vub,sig,vubar,v,r,gami,gam,
     + k)
              pgamdenom=probdenom(pgamnum,pgamdenom)
              if (ru(i)>pgamdenom) then
                  gam(i)=1
                  call update_vubar(vubar,gam,v,r,gami,k)
              endif
          else
              gami=-1
              pgamnum=probgambet(ldr,beta,vub,sig,vubar,v,r,gami,gam,k)
              gam(i)=1
              gami=i
              pgamdenom=probgambet(ldr,beta,vub,sig,vubar,v,r,gami,gam,
     + k)
              pgamdenom=probdenom(pgamnum,pgamdenom)
              if (ru(i)>pgamdenom) then
                  gam(i)=0
                  call update_vubar(vubar,gam,v,r,gami,k)
              endif
          endif
      enddo
      end


c     subroutine calculate prob beta,gamma
      real*8 function probgambet(ldr,beta,vub,sig,vubar,v,r,gami,gam,k)
      implicit none
      integer k,gam(k),gami
      real*8 beta(k),v(k,2),r(k,k),vubar(k,k),ldr,logdetvu
      real*8 vub(k),alpha,beta1,sig,ddot

      if (gami.ne.-1) then
          call update_vubar(vubar,gam,v,r,gami,k)
      endif

      alpha=1.0
      beta1=0.0
      call dgemv('n',k,k,alpha,vubar,k,beta,1,beta1,vub,1)
      probgambet=0.5*logdetvu(v,gam,ldr,k)-0.5/sig**2
     + *ddot(k,beta,1,vub,1)
      return
      end

      !compute bovobog
      real*8 function bovobog(gam,vbo,bo,k)
      implicit none
      integer k,gam(k),i
      real*8 vbo(k), bo(k)

      bovobog = 0.0
      do i=1,k
          if (gam(i).eq.1) then
              bovobog = bovobog + bo(i)*vbo(i)
          endif
      enddo
      return
      end function bovobog
      
        
      

      !preliminary calculation for spike slab prior
      !note fl = 0 (sample conditional on sig)
      real*8 function pspsl(qgam,vog,vo,gam,vbo,vbog,vu,
     + vug,vbu,bu, ypy,su,ifo,bog,nuo,fl,k)
      implicit none
      integer k,gam(k),qgam,ifo,info,i,nuo,fl
      real*8 vog(k,k),vo(k,k),vbo(k),vbog(k),vu(k,k)
      real*8 vug(k,k),vbu(k),bovobog,bvbo,bvbu,bu(k)
      real*8 su,ypy,so, ddot,bog(k)
     
      !initialise ifo
      ifo = 0 
        

      !compute adjusted vobar and vbobar
      call calcxpy(vbo,gam,vbog,k)
      call calcxpx(vo,gam,vog,k)

      !computed adjusted vubar
      call calcxpx(vu,gam,vug,k)

      !compute bvbu
      bvbu = bovobog(gam,vbu,bu,k)

           
      !compute bobar
      call dcopy(qgam,vbog,1,bog,1)
      call dposv('u',qgam,1,vog,k,bog,k,info)
      if (info.ne.0) then
          ifo = 1
      endif

      !compute bvbo
      bvbo = ddot(qgam,bog,1,vbog,1)


      !compute pspsl= 0.5*logdet(vug)
      call dpotrf('u',qgam,vug,k,info)
      if (info.ne.0) then
          ifo = 1
      endif


          pspsl=0.0
          do i=1,qgam
              pspsl = pspsl + log(vug(i,i))
          enddo

          !compute pspsl=pspsl-0.5*logdet(vog)
          if (info.ne.0) then
              ifo = 1
          endif

          do i=1,qgam
              pspsl=pspsl-log(vog(i,i))
          enddo

      if (fl.eq.0) then
          pspsl = pspsl + 0.5 * (bvbo - bvbu)
      else
          !compute sobar
          so = su + ypy - bvbo + bvbu

          !pspsl=pspsl-nuo/2*log(so/2)
          pspsl=pspsl-dble(nuo/2.0)*log(so/2.0)
      endif

      return 
      end function pspsl
      

c     Use stochastic search algorithm for spike slab prior      
      subroutine ssreg_sl(ini,vog,vo,gam,vbo,vbog,vu,vug,vbu,bu,ypy,
     + su,bog,nuo,ru,fl,k)

      implicit none
      integer k,gam(k),nuo,i,qgam, ifo,sumgam, fl,ini
      real*8 vog(k,k),vo(k,k),vbo(k),vbog(k),vu(k,k),vug(k,k)
      real*8 vbu(k),bu(k),ypy,su,bog(k),ru(k),pspsl
      real*8 pgamnum,pgamdenom,probdenom

cf2py intent(in) vog
cf2py intent(in) vo
cf2py intent(in) gam
cf2py intent(in) vbo
cf2py intent(in) vbog
cf2py intent(in) vu
cf2py intent(in) vug
cf2py intent(in) vbu
cf2py intent(in) bu
cf2py intent(in) ypy
cf2py intent(in) su
cf2py intent(in) bog
cf2py intent(in) nuo
cf2py intent(in) ru
cf2py intent(in) k

      do i=ini,k
          qgam=sumgam(gam,k)      
          if (gam(i).eq.1) then
              pgamnum = pspsl(qgam, vog, vo, gam, vbo, vbog, vu,
     + vug,vbu,bu, ypy, su, ifo, bog, nuo, fl, k)
              gam(i)=0
              qgam=qgam-1
              pgamdenom = pspsl(qgam, vog, vo, gam, vbo, vbog, vu,
     + vug, vbu, bu, ypy, su, ifo, bog, nuo, fl, k)
              pgamdenom=probdenom(pgamnum, pgamdenom)
              if (ru(i)>pgamdenom.or.ifo.ne.0) then
                  gam(i)=1
                  qgam=qgam+1
              endif
          else
              pgamnum = pspsl(qgam, vog, vo, gam, vbo, vbog, vu,
     + vug,vbu,bu, ypy, su, ifo, bog, nuo, fl, k)
              gam(i)=1
              qgam=qgam+1
              pgamdenom = pspsl(qgam, vog, vo, gam, vbo, vbog, vu,
     + vug, vbu, bu, ypy, su, ifo, bog, nuo, fl, k)
              pgamdenom=probdenom(pgamnum,pgamdenom)
              if (ru(i)>pgamdenom.or.ifo.ne.0) then
                  gam(i)=0
                  qgam=qgam-1
              endif
          endif
      enddo
      end
      

c     fortran 77 code used to calculate the likelihood of a log
c     linear model. Function uses BLAS.

      subroutine logl(xb,xm,bv,yv,llike,n,k)
      implicit none
      integer n, k, i
      real*8 xb(n),xm(n,k), bv(k), yv(n), llike
      real*8 alpha, beta

cf2py intent(in,out) llike
cf2py intent(in) yv
cf2py intent(ini bv
cf2py intent(in) xmat 
cf2py intent(in) xb 

      alpha=1.0
      beta=0.0
      call dgemv('n',n,k,alpha,xm,n,bv,1,beta,xb,1)

      llike=0.0
      do i=1,n
          llike=llike+yv(i)*xb(i)-exp(xb(i))
      enddo
      end

          
      

! Fortran 90 code used in the Bayesian estimation of GLMs
! Copyright (C) 2012  Chris Strickland

! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.

! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.

! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.


! File is fortran code to assist in the estimation of the generalised
! linear model.

!Fortran 90 code used in auxiliary mixture algorithm
!for binomial logit model.

!Fortran code to sample indicators
subroutine sample_ind(srvec, randu, svec, prvec, lweight, ptr, ystar, llamb, &
        n, nsw, np)
    implicit none

    !input parameters
    integer, intent(in) :: n, nsw, np
    integer, intent(in), dimension(np) :: ptr
    real(kind = 8), intent(inout), dimension(n) :: srvec
    real(kind = 8), intent(in), dimension(n) :: ystar, randu, llamb
    real(kind = 8), intent(in), dimension(nsw) :: svec, lweight
    real(kind = 8), dimension(5) :: prvec

    !local variables
    integer :: i, j, ncomp, st, en, sample_sr, l
    real(kind = 8) :: ressq

!$omp parallel default(shared) private(i,st,en,ncomp,l,j,ressq,prvec)
!$omp do schedule(static)
    do i=1,n
        st = ptr(i)
        en = ptr(i + 1) - 1
        !number of components
        ncomp = en - st + 1
        l = 1
        do j = st, en
            ressq = ((ystar(i) -  llamb(i)) / svec(j)) ** 2
            prvec(l) = lweight(j) - log(svec(j)) -0.5 * ressq
            l = l + 1
        enddo

        j = sample_sr(prvec(1:ncomp), randu(i), ncomp)
        srvec(i) = svec(j)
    enddo
!$omp end do
!$omp end parallel
    
end subroutine sample_ind

!Fortran function to sample component of srvec
integer function sample_sr(prvec, randu, np)
    implicit none
    !input parameters
    integer, intent(in) :: np
    real(kind = 8), intent(in) :: randu
    real(kind = 8), dimension(np) :: prvec

    !local variables 
    integer :: i
    real(kind = 8) :: cumpr, sumpr, maxpr

    !normalise probabilties
    maxpr = maxval(prvec)
    sumpr = log(sum(exp(prvec - maxpr))) + maxpr
    prvec = prvec - sumpr

    !sample from probability mass function
    i = 1
    cumpr = exp(prvec(i))
    do while (randu > cumpr)
        i = i + 1
        cumpr = cumpr + exp(prvec(i))
    enddo

    !select ith component
    sample_sr = i
    return
end function sample_sr

c     Used in PyMCMC for the stochastic search algorithm.    
c     Copyright (C) 2011  Chris Strickland
c
c     This program is free software: you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation, either version 3 of the License, or
c     (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program.  If not, see <http://www.gnu.org/licenses/>. 

c     Fortran 77 helper functions for regtools.py

c     calculates x'x
      subroutine calcxpx(x,xpx,n,k)
      implicit none
      integer n,k
      real*8 x(n,k),xpx(k,k)
      real*8 alpha,beta

cf2py intent(in) x
cf2py intent(inplace) xpx
      
      alpha=1.0
      beta=0.0
      call dgemm('t','n',k,k,n,alpha,x,n,x,n,beta,xpx,k)
      end subroutine calcxpx

c     calculates x'y
      subroutine calcxpy(x,y,xpy,n,k)
      implicit none
      integer n,k
      real*8 x(n,k),y(n),xpy(k)
      real*8 alpha,beta

cf2py intent(in) x
cf2py intent(in) y
cf2py intent(inplace) xpy
cf2py intent(in) n
cf2py intent(in) k

      alpha=1.0
      beta=0.0

      call dgemv('t',n,k,alpha,x,n,y,1,beta,xpy,1)
      end subroutine calcxpy

c     subroutine calculates sum of squared residuals
      subroutine sumsqres(so,res,n,k)
      implicit none
      integer n,k,i
      real*8 so(k),res(n,k)
      real*8 ddot

cf2py intent(inplace) so
cf2py intent(in) res

      do i=1,k
          so(i)=so(i)+ddot(n,res(:,i),1,res(:,i),1)
      enddo
      end subroutine sumsqres
          

c Helper Algorithms for PyMCMC - A Python package for Bayesian estimation
c Copyright (C) 2012  Chris Strickland

c This program is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.

c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.

c You should have received a copy of the GNU General Public License
c along with this program.  If not, see <http://www.gnu.org/licenses/>.# MCMC routines


      
      subroutine up_ssq(it,thb,lthb,th,ssq,k)
      implicit none
      integer it,k,i
      real*8 thb(k),lthb(k),th(k),ssq(k,k)
      real*8 a,b,alpha

cf2py intent(in) it
cf2py intent(in) thb
cf2py intent(in) lthb
cf2py intent(in) th
cf2py intent(inplace) ssq
cf2py intent(in) k


      a = dble(it)
      b = dble(it+1)
      alpha = (a-1.0) / a

      do i=1,k
          thb(i)=(a*thb(i)+th(i))/b
          call dscal(k,alpha,ssq(:,i),1)
      enddo
      alpha = 1.0

      call dger(k,k,alpha,lthb,1,lthb,1,ssq,k)
      alpha = -b / a
      call dger(k,k,alpha,thb,1,thb,1,ssq,k)
      alpha = 1.0 / a
      call dger(k,k,alpha,th,1,th,1,ssq,k)
      
      end subroutine up_ssq
      

c ----------------------------------------------------------------------
c Fortran 77 code used in the calculation of the mixture model
c Copyright (C) 2011  Chris Strickland

c This program is free software: you can redistribute it and/or modify
c it under the terms of the GNU General Public License as published by
c the Free Software Foundation, either version 3 of the License, or
c (at your option) any later version.

c This program is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c GNU General Public License for more details.

c You should have received a copy of the GNU General Public License
c along with this program.  If not, see <http://www.gnu.org/licenses/>.
c ----------------------------------------------------------------------
c ----------------------------------------------------------------------      

c Purpose
c =======
c
c The subroutine calcxxp is used to the outer product
c xxp(:,:,i) =  x(i,:) * x(i,:)' for i = 1, 2, ..., n,
c where x ix an (n x k) matrix of regressors.
c
c Arguments
c =========
c 
c xxp - A (k x k x n) array. On entry should be zeros.
c       On output contains the outer product
c       xxp(:,:,i) =  x(i,:) * x(i,:)',
c       for i = 1, 2, ..., n.
c
c x - An (n x k) matrix of regressors.
c
c k - An integer that denotes the number of regressors.
c      
c n - An integer that denotes the number of observations
c     in the analysis.
c
c =====================================================

      subroutine calcxxp(xxp,x,k,n)
      implicit none
      integer k,n,i
      real*8 xxp(k,k,n),x(n,k)
      real*8 alpha

      alpha=1.0

cf2py intent(inout) xxp
cf2py intent(in) x
cf2py intent(in) k
cf2py intent(in) p
      
      do i=1,n
c         outer product
          call dger(k,k,alpha,x(i,:),1,x(i,:),1,xxp(:,:,i),k)
      enddo
      end

c ----------------------------------------------------------------------
c ----------------------------------------------------------------------

c Purpose
c =======
c
c The subroutine calcxpy calculates 
c xpy = sum(x(i,:)(y(i) - alpha(index)) * s2(index))),
c where the sum is computed over i = 1, 2, ..., n. The term
c index references the component of the mixture for observation
c i.
c
c Arguments
c =========
c 
c xpy - Is a (k x 1) vector. On exit contains the computation of
c       interest.
c
c y - Is an (n x 1) vector of observations.
c      
c x - Is an (n x k) matrix of regressors.
c
c xs - Is a (k x 1) work array.
c
c a - Is an (nm x 1) vector containing the nm means of the mixture.
c
c s2 - Is an (nm x 1) vector containing the nm variances of the mixture.
c
c e - Is an (n x 1) integer vector, which specifies the component of the 
c     mixture for each observations.
c
c n - Is an integer that denotes the number of observations.
c 
c nm - Is an integer that denotes the number of components in the model.
c
c k - Is an integer that denotes the number of regressors in the model.
c      
c =====================================================


      subroutine calcxpy(xpy,y,x,xs,a,s2,e,n,nm,k)
      implicit none
      integer n,nm,k,i,j
      real*8 y(n),x(n,k),xs(k),a(nm),s2(nm),ys
      real*8 xpy(k),alpha
      integer e(n)

cf2py intent(inout) xpy
cf2py intent(in) y
cf2py intent(in) x
cf2py intent(in) xs
cf2py intent(in) a
cf2py intent(in) s2
cf2py intent(in) e
cf2py intent(in) n
cf2py intent(in) nm
cf2py intent(in) k

      alpha=1.0

c     Initialise xpy setting each element. 0.0
      do j=1,k
          xpy(j)=0.0
      enddo

      do i=1,n
          ys=(y(i)-a(e(i)+1))*s2(e(i)+1)  
          do j=1,k
              xs(j)=x(i,j)*ys
          enddo

          call daxpy(k,alpha,xs,1,xpy,1)
      enddo
      end

c ----------------------------------------------------------------------
c ----------------------------------------------------------------------

c Purpose
c =======
c
c The subroutine calcvobar computes the posterior precision for the
c regression coefficients.
c
c Arguments
c =========
c 
c vu - Is a (nr x nr) matrix that on entry contains the prior precision
c      for the regression coefficients.
c
c vo - Is a (nr x nr) matrix that on exit contains the posterior
c      precision for the regressors.
c
c xxp - Is an (nr x nr, n) array that contains the outer product
c       xxp(:,:,i) =  x(i,:) * x(i,:)',
c       for i = 1, 2, ..., n.
c
c sigj - Is an (nm x 1) vector that contains the standard deviations
c        for each component of the mixture.
c
c e - Is an (n x 1) integer vector, which specifies the component of the 
c     mixture for each observations.
c
c nr - Is an integer that denotes the number of regressors in the model.
c      
c n - Is an integer that denotes the number of observations.
c 
c nm - Is an integer that denotes the number of components in the model.
c
c =====================================================

      subroutine calcvobar(vu,vo,xxp,sigj,e,nr,n,nm)
      implicit none
      integer nr,n,i,nm,j
      real*8 vu(nr,nr),vo(nr,nr),xxp(nr,nr,n),sigj(nm)
      real*8 alpha
      integer e(n)

cf2py intent(in) vu
cf2py intent(inout) vo
cf2py intent(in) xxp
cf2py intent(in) sigj
cf2py intent(in) e
cf2py intent(in) nr
cf2py intent(in) n

      do i=1,nr
          call dcopy(nr,vu(:,i),1,vo(:,i),1)
      enddo

      do i=1,n
          alpha=sigj(e(i)+1)
          do j=1,nr
              call daxpy(nr,alpha,xxp(:,j,i),1,vo(:,j),1)
          enddo
      enddo
      end

c ----------------------------------------------------------------------
c Purpose
c =======
c
c Subroutine calculates the posterior precision for alpha
c
c Arguments
c =========
c 
c vu - Is an (nm x nm) matrix that on entry specifies the prior precision
c      matrix for alpha
c
c vo - Is an (nm x nm) matrix that on exit specifies the posterior precision
c      matrix for alpha
c
c e - Is an (n x 1) integer vector, which specifies the component of the 
c     mixture for each observations.
c
c sig - Is an (nm x 1) vector, which specifies the standard deviation
c       for each component in the mixture.
c
c nm - Is an integer that denotes the number of components in the model.
c
c n - Is an integer that denotes the number of observations.
c
c =====================================================


      subroutine calcvobara(vu,vo,e,sig,nm,n)
      implicit none
      integer nm,n,i,ind,e(n)
      real*8 vu(nm,nm),vo(nm,nm),sig(nm)

cf2py intent(in) vu
cf2py intent(inout) vo
cf2py intent(in) e
cf2py intent(in) sig
cf2py intent(in) nr
cf2py intent(in) n

      do i=1,nm
          call dcopy(nm,vu(:,i),1,vo(:,i),1)
      enddo

      do i=1,n
          ind=e(i)+1
          vo(ind,ind)=vo(ind,ind)+1.0/sig(ind)
      enddo
      end

c ----------------------------------------------------------------------

c Purpose
c =======
c
c The purpose of calcvbobara is the calculate the product
c of the posterior precision for alpha and the posterior mean
c for alpha.
c
c Arguments
c =========
c 
c vau - Is an (nm x 1) vector that on entry contains the prior precision
c       for alpha multiplied by the prior mean for alpha.
c
c vao - Is an (nm x 1) vector that on exit contains the posterior
c       precision for alpha multiplied by the posterior mean for alpha.
c
c
c sig - Is an (nm x 1) vector, which specifies the standard deviation
c       for each component in the mixture.
c
c e - Is an (n x 1) integer vector, which specifies the component of the 
c     mixture for each observations.
c
c n - Is an integer that denotes the number of observations.
c
c nm - Is an integer that denotes the number of components in the model.
c
c =====================================================

      subroutine calcvbobara(vau,vao,sig,e,y,n,nm)
      implicit none
      integer n,nm,i,e(n)
      real*8 vau(nm),vao(nm),sig(nm),y(n)

cf2py intent(in) vau
cf2py intent(inout) vao
cf2py intent(in) sig
cf2py intent(in) e
cf2py intent(in) y
cf2py intent(in) n
cf2py intent(in) nm

      call dcopy(nm,vau,1,vao,1)
      do i=1,n
          vao(e(i)+1)=vao(e(i)+1)+y(i)/sig(e(i)+1)
      enddo
      end
      
c ----------------------------------------------------------------------

c Purpose
c =======
c
c sim_evec is used to sample the an n - dimensional vector
c that is an allocation index for the mixture.
c
c Arguments
c =========
c 
c e - Is a n - dimensional integer vector. On exit it stores the
c     allocations for the mixture.
c
c ru - Is a n - dimensional vector of random uniforms.
c
c y - Is a n - dimensional vector of observations.
c
c lp - Is an (nm x n) matrix of log probabilities.
c
c al - Is an (nm x 1) vector that stores alpha.
c
c s - Is an (nm x 1) vector that stores mixture variances.
c
c p - Is an (nm, n) matrix that store pobar.
c
c pp - Is an (nm) matrix that stores p.
c
c nm - Is an integer that denotes the number of components in the
c      mixture.
c
c n - Is an integer that denotes the number of observations.
c
c =====================================================

      subroutine sim_evec(e,ru,y,lp,al,s,p,pp,nm,n)
      implicit none
      integer n,nm,i,j
      integer e(n)
      real*8 y(n),al(nm),s(nm),p(nm,n),lp(nm,n),ru(n)
      real*8 log_norm,pp(nm)

cf2py intent(inout) e
cf2py intent(in) ru
cf2py intent(in) y
cf2py intent(in) lp
cf2py intent(in) al
cf2py intent(in) s
cf2py intent(in) p
cf2py intent(in) n
cf2py intent(in) nm


c$omp parallel shared(lp,al,s,pp,p,ru,e) private(i,j)

c$omp do schedule(static)
      do i=1,n
          do j=1,nm
              lp(j,i)=log_norm(y(i),al(j),s(j)**2)+pp(j)
          enddo
 
          call calc_pe(lp,p,ru,e,i,nm,n)
      enddo
c$omp end do
c$omp end parallel
      end subroutine sim_evec
c ----------------------------------------------------------------------

c Purpose
c =======
c
c sim_evec_m is used to sample the an n - dimensional vector
c that is an allocation index for the mixture in the multivariate
c case.
c
c Arguments
c =========
c 
c e - Is a n - dimensional integer vector. On exit it stores the
c     allocations for the mixture.
c
c ru - Is a n - dimensional vector of random uniforms.
c
c y - Is a (d x n) dimensional matrix of observations.
c
c lp - Is an (nm x n) matrix of log probabilities.
c
c al - Is an (d x nm) matrix that stores mixture means.
c
c s - Is an (d x d x nm) array that stores mixture precisions.
c
c p - Is an (nm, n) matrix that store pobar.
c
c pp - Is an (nm) matrix that stores p.
c
c wk - Is an (d x 2) work matrix.
c
c lds - Is an(nm) vector of log determinates of s
c
c nm - Is an integer that denotes the number of components in the
c      mixture.
c
c n - Is an integer that denotes the number of observations.
c
c d - Is an integer that denotes the multivariate dimension.
c
c =====================================================

      subroutine sim_evec_m(e,ru,y,lp,al,s,lds,p,pp,wk,nm,n,d)
      implicit none
      integer n,nm,i,j,d
      integer e(n)
      real*8 y(d,n),al(d,nm),s(d,d,nm),p(nm,n),lp(nm,n),ru(n)
      real*8 log_normm,pp(nm),wk(d,2),lds(nm)

cf2py intent(inout) e
cf2py intent(in) ru
cf2py intent(in) y
cf2py intent(in) lp
cf2py intent(in) al
cf2py intent(in) s
cf2py intent(in) p
cf2py intent(in) n
cf2py intent(in) nm


c$omp parallel default(shared) private(i,j,wk)
c$omp do schedule(static)
      do i=1,n
          do j=1,nm
              lp(j,i)=log_normm(y(:,i),al(:,j),s(:,:,j),
     + wk,d)+pp(j)+0.5*lds(j)
          enddo
 
          call calc_pe(lp,p,ru,e,i,nm,n)
      enddo
c$omp end do
c$omp end parallel
      end subroutine sim_evec_m

c Purpose
c =======
c
c The calc_pe computes the posterior probability of
c membership to each of the k components and the 
c simulates e (indicators).
c
c Arguments
c =========
c   
c lp - Is an (nm x n) matrix of log probabilities.
c
c p - Is an (nm, n) matrix that store pobar.
c
c e - Is a n - dimensional integer vector. On exit it stores the
c     allocations for the mixture.
c
c i - Is an integer that is used to increment in loop
c
c ru - Is a n - dimensional vector of random uniforms.
c
c =====================================================

      subroutine calc_pe(lp,p,ru,e,i,nm,n)
      implicit none
      
      integer n,nm,i,j
      integer e(n)
      real*8 p(nm,n),lp(nm,n),ru(n)
      real*8 suml,sl
      integer sime
      
      sl=suml(lp(:,i),nm)
      do j=1,nm
          p(j,i)=exp(lp(j,i)-sl)
      enddo
      
      e(i)=sime(p(:,i),ru(i),nm)
      !print *, p(:,i), sum(p(:,i)), e(i)
      end subroutine calc_pe
      


c ----------------------------------------------------------------------

c Purpose
c =======
c
c sim_evec_sp is used to sample the an n - dimensional vector
c that is an allocation index for the spatial mixture.
c
c Arguments
c =========
c 
c e - Is a n - dimensional integer vector. On exit it stores the
c     allocations for the mixture.
c
c ru - Is a n - dimensional vector of random uniforms.
c
c y - Is a n - dimensional vector of observations.
c
c lp - Is an (nm x n) matrix of log probabilities.
c
c al - Is an (nm x 1) vector that stores mixture means.
c
c s - Is an (nm x 1) vector that stores the mixture variances.
c
c p - Is an (nm, n) matrix that store pobar.
c
c ne - Is an (nm, n) matrix that stores p.
c
c b - Is a spatial dependence parameter.
c
c nm - Is an integer that denotes the number of components in the
c      mixture.
c
c n - Is an integer that denotes the number of observations.
c
c =====================================================

      subroutine sim_evec_sp(e,ru,y,lp,al,s,p,ne,b,nm,n)
      implicit none
      integer n,nm,i,j
      integer e(n)
      real*8 y(n),al(nm),s(nm),p(nm,n),lp(nm,n),ru(n)
      real*8 log_norm,ne(nm,n),b

cf2py intent(inout) e
cf2py intent(in) ru
cf2py intent(in) y
cf2py intent(inout) lp
cf2py intent(in) al
cf2py intent(in) s
cf2py intent(inout) p
cf2py intent(in) ne
cf2py intent(in) b
cf2py intent(in) n
cf2py intent(in) nm


c$omp parallel shared(lp,al,s,ne,p,ru,e,b) private(i,j)

c$omp do schedule(static)
      do i=1,n
          do j=1,nm
              lp(j,i)=log_norm(y(i),al(j),s(j)**2)+b*ne(j,i)
          enddo
          
          call calc_pe(lp,p,ru,e,i,nm,n)
      enddo
c$omp end do
c$omp end parallel
      end


c ----------------------------------------------------------------------

c Purpose
c =======
c
c sim_evec_spmv is used to sample the an n - dimensional vector
c that is an allocation index for the spatial multivariate mixture.
c
c Arguments
c =========
c 
c e - Is a n - dimensional integer vector. On exit it stores the
c     allocations for the mixture.
c
c ru - Is a n - dimensional vector of random uniforms.
c
c y - Is a d x n- dimensional matrix of observations.
c
c lp - Is an (nm x n) matrix of log probabilities.
c
c al - Is an (d x nm) matrix that stores mixture means.
c
c s - Is an (d x d x nm) array that stores mixture precisions.
c
c p - Is an (nm, n) matrix that store pobar.
c
c ne - Is an (nm, n) matrix that stores current neighbour allocations.
c
c wk - Is an (d x 2) work matrix.
c
c lds - Is an (nm) vector of log determinates of s
c
c b - Is a spatial dependence parameter.
c
c nm - Is an integer that denotes the number of components in the
c      mixture.
c
c n - Is an integer that denotes the number of observations.
c
c d - Is an integer of the number variables in the multivariate mixture
c =====================================================

      subroutine sim_evec_spmv(e,ru,y,lp,al,s,p,ne,b,lds,wk,nm,n,d)
      implicit none
      integer n,nm,i,j,d,sum_b
      integer e(n)
      real*8 y(d,n),al(d,nm),s(d,d,nm),p(nm,n),lp(nm,n),ru(n)
      real*8 log_normm,ne(nm,n),b,wk(d,2),lds(nm)
      real*8 tmp(nm),tmp2

cf2py intent(inout) e
cf2py intent(in) ru
cf2py intent(in) y
cf2py intent(in) lp
cf2py intent(in) al
cf2py intent(in) s
cf2py intent(inout) p
cf2py intent(in) ne
cf2py intent(in) b
cf2py intent(in) n
cf2py intent(in) nm
cf2py intent(in) d


c$omp parallel shared(lp,al,s,ne,p,ru,e,b) private(i,j)

c$omp do schedule(static)
      
      do i=1,n
                    
          do j=1,nm
              lp(j,i)=log_normm(y(:,i),al(:,j),s(:,:,j),
     +                wk,d)+0.5*lds(j)+b*ne(j,i)
                         
          enddo
          
          call calc_pe(lp,p,ru,e,i,nm,n)
      enddo
c$omp end do
c$omp end parallel

      !print *, "Means used in sim_evec_spmv"
      !print *, n, sum(e)
      !print *, al(:,:)
      !print *, b

      end

c ----------------------------------------------------------------------

c Purpose
c =======
c
c The function sime samples from a Multinomial(1,p)
c
c Arguments
c =========
c 
c p - An (n x 1) vector of probabilites
c
c ru - A scalar that is a draw from U(0,1)
c
c n - An integer that denotes the length of p.
c
c =====================================================

      integer function sime(p,ru,n)
      implicit none
      integer n
      real*8 p(n),ru,cp
    
      cp=0.0
      sime=0
      cp=p(1)
      do while (ru.gt.cp)
          sime=sime+1
          cp=cp+p(sime+1)
      enddo
      return 
      end


c ----------------------------------------------------------------------

c Purpose
c =======
c
c The function log-norm computes the log of the normal pdf up to
c a constant. 
c
c Arguments
c =========
c 
c y - A scalar argument for the density,
c
c m - A scalar that denotes the mean of the density.
c
c ssq - A scalar denoting the variance of the density.
c
c =====================================================

      real*8 function log_norm(y,m,ssq)
      implicit none
      real*8 y,m,ssq

      log_norm=-0.5*(log(ssq)+(y-m)**2/ssq)
      return
      end

c Purpose
c =======
c
c The function log_normm computes the log of the multivariate normal
c pdf up to a constant
c
c Arguments
c =========
c 
c y - A (px1) vector
c
c =====================================================

      real*8 function log_normm(y,mean,prec,wk,p)
      implicit none
      integer p
      real*8 y(p),mean(p),prec(p,p),wk(p,2)
      real*8 alpha,beta,ddot

      !wk - y - m
      alpha=-1.0
      call dcopy(p,y,1,wk(:,1),1)
      call daxpy(p,alpha,mean,1,wk(:,1),1)
      alpha=1.0
      beta=0.0
      call dsymv('u',p,alpha,prec,p,wk(:,1),1,beta,wk(:,2),1)
      log_normm = -0.5 * ddot(p,wk(:,1),1,wk(:,2),1)
      
      return
      end function log_normm


c Purpose
c =======
c
c Function computes the log-normal distrbution
c
c Arguments
c =========
c 
c y - Is a (n x p) matrix of observations
c
c mean - Is an (p x 1) mean vector
c
c cvar - Is an (p x p) lower Cholesky triangle from the 
c        Cholesky decomposition of the variance,
c   
c wk - Is a (p x 1) work vector.
c
c p - Is the number of multivariate observations.
c
c n - Is the number of observations.
c
c =====================================================

      real*8 function log_normm_f(y, mean, cvar, wk, p, n)
      implicit none

      integer p,n,i
      real*8 y(p,n),mean(p),cvar(p,p),wk(p)
      real*8 alpha,ddot

c     compute half log determinant
      log_normm_f = 0.0
      do i=1,p
          log_normm_f = log_normm_f- log(cvar(i,i))
      enddo
      
     

      do i=1,n
          !wk - y - m
          alpha=-1.0
          call dcopy(p,y(:,i),1,wk,1)
          call daxpy(p,alpha,mean,1,wk,1)

          !wk(:,1)'inv(var)*wk(:,1)
          call dtrsv('l','n','n',p,cvar,p,wk,1)
          log_normm_f = log_normm_f -0.5 * ddot(p,wk,1, wk,1)
      enddo
      return
      end function log_normm_f
      

      



c ----------------------------------------------------------------------
c Purpose
c =======
c
c The function suml returns the log sum of an array of of logs.
c
c Arguments
c =========
c 
c lx - An (n x 1) vector of logged reals
c
c n - A integer denoting the number of logged reals.
c
c =====================================================
      
      real*8 function suml(lx,n)
      implicit none
      integer n,i
      real*8 maxl,lx(n)

      suml=0.0
      maxl=lx(1)
      do i=2,n
          if (lx(i).gt.maxl) then
              maxl=lx(i)
          endif
      enddo
        
      do i=1,n
          suml=suml+exp(lx(i)-maxl)
      enddo
      suml=log(suml)+maxl

      return
      end function suml

c ----------------------------------------------------------------------

c Purpose
c =======
c
c The subroutine neighbj computes the number of neighbouring
c  pixels that in component j, for pixel i. 
c
c Arguments
c =========
c 
c ne - Is an (nm, n) matrix.
c
c e - Is a n - dimensional integer vector. On exit it stores the
c     allocations for the mixture.
c
c nn - 
c
c indn - A (li x 1) vector of integers which is an array of 
c        neighbouring indicies stacked on top of each others. 
c        See mix_model.py for an example.
c
c b - A scalar.
c
c nm - Is an integer that denotes the number of components in the
c      mixture.
c
c n - Is an integer that denotes the number of observations.
c
c li - Is an integer that denotes the length of indn
c
c =====================================================

      subroutine  neighbj(ne,e,nn,indn,nm,n,li)
      implicit none

      integer nm,n,li,e(n),indn(li),nn(n+1)
      integer i,j,k,st,en,countj
      real*8 ne(nm,n)

cf2py intent(inout) ne
cf2py intent(in) e  
cf2py intent(in) nn
cf2py intent(in) indn
cf2py intent(in) b

c$omp parallel shared(nn,e,indn) private(i,j,st,en,countj)
c$omp do schedule(static)
      do i=1,n
          st=nn(i)
          en=nn(i+1)-1
                    
          do j=1,nm
              countj=0
              do k=st,en
	          if (e(indn(k))+1.eq.j) then
                      countj=countj+1
                  endif
              enddo
                  
              ne(j,i)=dble(countj)
          enddo
      enddo
c$omp end do
c$omp end parallel
      
      end subroutine neighbj


c ----------------------------------------------------------------------

c Purpose
c =======
c
c Function that evaluates the psuedo likelihood for the 
c spatial mixture potts model, given p and e.
c
c Arguments
c =========
c 
c ne - Is an (nm, n) matrix.
c
c e - Is a n - dimensional integer vector. On exit it stores the
c     allocations for the mixture.
c
c n - Is an integer that specifies the number of observations.
c
c k - Is an integer that specifies the number of components in the 
c     in the mixture.
c
c =====================================================


      real*8 function pseudolike(ne,e,b,n,k)
      implicit none
      integer n,k,e(n),i,j
      real*8 num,denom,tdenom,ne(k,n),b

cf2py intent(in) p
cf2py intent(in) e
cf2py intent(in) b
cf2py intent(in) n
cf2py intent(in) k


      num=0.0
      denom=0.0
c$omp parallel shared(ne,e,b) private(i,tdenom,j)
c$omp do reduction(+:num,denom)
      do i=1,n
          num=num+ne(e(i)+1,i)
          tdenom=0.0
          do j=1,k
              tdenom=tdenom+exp(b*ne(j,i))
          enddo
          denom=denom+log(tdenom)
      enddo
c$omp end parallel

      pseudolike=b*num-denom
      
      return
      end function pseudolike
            
c ----------------------------------------------------------------------
     
c Purpose
c =======
c
c The subroutine calcsobar, calculates sobar, which is one of the hyperparamters
c that describe the posterior for sigma.
c
c Arguments
c =========
c 
c rv - Is an (n x 1) work vector.
c
c y - Is the (n x 1) vector of observations. 
c
c e - Is the (n x  1) allocation vector for the mixtures.
c
c a - Is the (nm x 1) vector that provides the means for each component
c     in the mixture
c su - Is an (nm x 1) prior hyperparameter.
c
c so - Is an (nm x 1) vector that on exit is a posterior hyperameter.
c
c nm - Is an integer that defines the number of components in the
c      mixture.
c
c n - Is an integer the defines the number of observations.
c
c =====================================================

      subroutine calcsobar(rv,y,e,a,su,so,nm,n)
      implicit none
      integer nm,n,j,i,e(n)
      real*8 rv(n),y(n),su(nm),so(nm),a(nm)
      real*8 sosum

cf2py intent(in) rv
cf2py intent(in) y
cf2py intent(in) e
cf2py intent(in) a
cf2py intent(in) su
cf2py intent(inout) so
cf2py intent(in) nm
cf2py intent(in) n


c$omp parallel shared(e,y,a,su,so,rv) private(j,sosum,i)
c$omp do schedule(static)
      do i=1,n
          rv(i)=(y(i)-a(e(i)+1))**2
      enddo
c$omp end do
      
c$omp do schedule(static)
      do j=1,nm
          sosum=su(j)
          do i=1,n
              if (e(i)+1.eq.j) then
                  sosum=sosum+rv(i)
              endif
          enddo
          so(j)=sosum
      enddo
c$omp end do
c$omp end parallel

      end subroutine calcsobar


c Purpose
c =======
c
c calcsobar2 computes the scaling factor for simulating
c for the gamma distribution
c
c Arguments
c =========
c 
c y - Is an (n x 1) vector of observations.
c
c ybarj - Is an (nc x 1) vector of means for allocated y
c
c nj - Is an (nc x 1) integer vector that stores component
c      component allocation numbers
c
c e - Is the (n x  1) allocation vector for the mixtures.
c
c su - Is an (nc x 1) prior hyperparameter.
c
c so - Is an (nc x 1) vector that on exit is a posterior hyperameter.
c
c au - Is an (nc x 1) vector of hyperparmeters for component means.
c  
c mj - Is an (nc x 1) vector of hyperparameters for component mean
c     sample size.
c
c n - Is an integer that is the sample size
c
c nc - Is an integer for the number of components in the mixture
c
c =====================================================


c ---------------------------------------------------------------------
      subroutine calcsobar2(y,ybarj,nj,e,su,so,au,mj,n,nc)
      implicit none
      integer n,nc,e(n),nj(nc),j,i
      real*8 su(nc),so(nc),y(n)
      real*8 ybarj(nc),au(nc),mj(nc),sumysq,sj
      real*8 zeta

cf2py intent(in) y
cf2py intent(in) e
cf2py intent(in) su
cf2py intent(inplace) so
cf2py intent(inplace) ybarj
cf2py intent(inplace) nj
cf2py intent(in) au
cf2py intent(in) mj
cf2py intent(in) n
cf2py intent(in) nc

      do j = 1, nc
          sumysq = 0.0
          ybarj(j) = 0.0
          nj(j) = 0          

          do i = 1, n
              if (e(i)+1.eq.j) then
                  sumysq = sumysq + y(i)**2
                  ybarj(j) = ybarj(j) + y(i)
                  nj(j) = nj(j) + 1
              endif
          enddo
         
          !Note correction for the case when there is component
          !j is empty
          if (nj(j).eq.0) then
              ybarj(j) = 0.0
          else
              ybarj(j) = ybarj(j) /dble(nj(j))
          endif
          sj = sumysq - nj(j) *ybarj(j)**2
          zeta = dble(nj(j) *mj(j)) / dble(nj(j) +mj(j))
          so(j) = su(j) +sj + zeta * (ybarj(j)-au(j))**2
          
      enddo  
      !print *,ybarj
      end subroutine calcsobar2
      
     
c Purpose
c =======
c
c calcsobarm computes the scaling factor for simulating
c from the Wishart distribution.
c
c Arguments
c =========
c 
c y - Is an (d x n) matrix of observations.
c
c ybarj - Is an (d x nc) matrix of means for allocated y
c
c nj - Is an (nc x 1) integer vector that stores component
c      component allocation numbers
c
c e - Is the (n x  1) allocation vector for the mixtures.
c
c su - Is an (d x d x nc) array of prior hyperparameter.
c
c so - Is an (d x d x nc) array that on exit is a posterior hyperameter.
c
c au - Is an (d x nc) matrix of hyperparmeters for component means.
c
c sumysq - Is a (d x d) work matrix
c
c mj - Is an (nc x 1) vector of hyperparameters for component mean
c     sample size.
c
c n - Is an integer that is the sample size
c
c nc - Is an integer for the number of components in the mixture
c
c =====================================================


c ---------------------------------------------------------------------
      subroutine calcsobarm(y,ybarj,nj,e,su,so,au,sumysq,mj,n,nc,d)
      implicit none
      integer n,nc,e(n),nj(nc),j,i,k,d
      real*8 su(d,d,nc),so(d,d,nc),y(d,n)
      real*8 ybarj(d,nc),au(d,nc),mj(nc),sumysq(d,d)
      real*8 zeta,alpha

cf2py intent(in) y
cf2py intent(in) e
cf2py intent(in) su
cf2py intent(inplace) so
cf2py intent(inplace) ybarj
cf2py intent(inplace) nj
cf2py intent(in) au
cf2py intent(in) mj
cf2py intent(in) n
cf2py intent(in) nc
cf2py intent(in) d


      do j = 1, nc
          do k=1,d
              ybarj(k,j)=0.0
              do i=1,d
                  sumysq(i,k)=0.0
              enddo
          enddo
          
          nj(j) = 0          

          do i = 1, n
              if (e(i)+1.eq.j) then
                  alpha=1.0
                  !sumysq = sumysq + alpha * y(:,i) * y(:,i)'
                  call dger(d,d,alpha,y(:,i),1,y(:,i),1,sumysq,d)

                  !ybar(:,j) = y(bar(j) + alpha * (y(:,i)
                  call daxpy(d,alpha,y(:,i),1,ybarj(:,j),1)
                  nj(j) = nj(j) + 1
              endif
          enddo
    
          !print*
          !print*, "sumysq"
          !do i=1,d
          !    write(*,*) (sumysq(i,k), k=1,d)
          !enddo

          !print*
          !print*, "ybarj", ybarj(:,j)
         
          !Note correction for the case when there is component
          !j is empty
          if (nj(j).eq.0) then
              do k=1,d
                  ybarj(k,j)=0.0
              enddo
          else
              !ybarj(:,j) = ybar(:,j) / nj(j)
              alpha=1.0/dble(nj(j))
              call dscal(d,alpha,ybarj(:,j),1)
          endif
          alpha=1.0
          do k=1,d
              !so(:,k) = sumysq(:,k) 
              call dcopy(d,sumysq(:,k),1,so(:,k,j),1)
              !so = so + su
              call daxpy(d,alpha,su(:,k,j),1,so(:,k,j),1)
          enddo

          alpha=-dble(nj(j))
          !so = so -nj(j) * ybarj * ybarj'
          call dger(d,d,alpha,ybarj(:,j),1,ybarj(:,j),1,so(:,:,j),d)
          
          zeta = dble(nj(j) *mj(j)) / dble(nj(j) +mj(j))

          !Use sumysq(:,1) as work vector
          !sumysq(:,1)=ybarj(:,j)-au(:,j)
          alpha=-1.0
          call dcopy(d,ybarj(:,j),1,sumysq(:,1),1)
          call daxpy(d,alpha,au(:,j),1,sumysq(:,1),1)

          !so = so + zeta * sumysq(:,1)*sumysq(:,1)'
          call dger(d,d,zeta,sumysq(:,1),1,sumysq(:,1),1,so(:,:,j),d)
      enddo  

      end subroutine calcsobarm
      
     
c ----------------------------------------------------------------------
      
c Purpose
c =======
c
c The subroutine calcsobarr, calculates sobar for the case,
c regressors are included in the model. 
c
c Arguments
c =========
c 
c rv - Is an (n x 1) work vector.
c
c y - Is the (n x 1) vector of observations. 
c
c e - Is the (n x  1) allocation vector for the mixtures.
c
c xb - Is an (n x 1) vector that is defined by x * b, where
c      x is an (n x k) matrix of regressors and b is a (k x 1) vector
c      of regression coefficients. 
c      
c a - Is the (nm x 1) vector that provides the means for each component
c     in the mixture
c su - Is an (nm x 1) prior hyperparameter.
c
c so - Is an (nm x 1) vector that on exit is a posterior hyperameter.
c
c nm - Is an integer that defines the number of components in the
c      mixture.
c
c n - Is an integer the defines the number of observations.
c
c =====================================================

      subroutine calcsobarr(rv,y,e,xb,a,su,so,nm,n)
      implicit none
      integer nm,n,j,i,e(n)
      real*8 rv(n),y(n),su(nm),so(nm),a(nm)
      real*8 sosum,xb(n)

cf2py intent(in) rv
cf2py intent(in) y
cf2py intent(in) e
cf2py intent(in) x
cf2py intent(in) a
cf2py intent(in) su
cf2py intent(inout) so
cf2py intent(in) nm
cf2py intent(in) n


c$omp parallel shared(rv,e,y,a,su,so,xb) private(j,sosum,i)
c$omp do schedule(static)
      do i=1,n
          rv(i)=(y(i)-a(e(i)+1)-xb(i))**2
      enddo
c$omp end do

c$omp do schedule(static)
      do j=1,nm
          sosum=su(j)
          do i=1,n
              if (e(i)+1.eq.j) then
c                  rv=(y(i)-a(e(i)+1)-xb(i))**2
                  sosum=sosum+rv(i)
              endif
          enddo
          so(j)=sosum
      enddo
c$omp end do
c$omp end parallel

      end subroutine calcsobarr

c Purpose
c =======
c
c Compute the cost matrix
c
c Arguments
c =========
c 
c argument - description
c
c =====================================================

      subroutine cost_matrix(evec, cw_evec, costm, nmix, n)
      implicit none
      integer nmix, n, i, j, k
      real*8 evec(n), cw_evec(n), costm(nmix, nmix)

cf2py intent(in) evec
cf2py intent(in) cw_evec
cf2py intent(inout) costm

      do i=1,n
          do j=1,nmix
              do k=1,nmix
                  if (cw_evec(i).eq.j.and.evec(i).ne.k) then
                      costm(j,k) = costm(j,k) + 1
                  endif
              enddo
          enddo
      enddo
      end subroutine cost_matrix
      




c ----------------------------------------------------------------------

c Purpose
c =======
c
c The function num_threads returns the number of openmp threads
c
c =====================================================
!      integer function num_threads()
!      implicit none
!      integer omp_get_num_threads
!      num_threads = omp_get_num_threads()
!      return
!      end function num_threads

c ----------------------------------------------------------------------      
